////////////////////////////////////////////////////////////////////////////////
// File         : NodesNumbers.cpp
// Subsystem    : Graph
// Component    : trace objects
// Author       : Josef Huebl, (Josef.Huebl@sss.de)
// Description  : implementation of the class NodesNumbers
////////////////////////////////////////////////////////////////////////////////
// Copyright (C) Triple-S GmbH (www.sss.de) 2003
// Alle Rechte vorbehalten. All Rights Reserved.
//
// The reproduction, transmission or use of this document or its contents is
// not permitted without express written authority.
// Offenders will be liable for damages. All rights, including rights created
// by patent grant or registration of a utility model or design, are reserved.
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// History:
// 10.10.03    Josef Huebl       created
// 17.12.03    Josef Huebl       1. released version.
// 30.05.06    Josef Huebl       some extensions
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Hints:      
//     
//     
////////////////////////////////////////////////////////////////////////////////


#include "NodesNumbers.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////
// public
//////////////////////////////////////////////////////////////////////

void NodesNumbers::Copy( const NodesNumbers &numb, const Node &n, const Node &nOrig )
{
	m_currentNodeID = numb.m_currentNodeID;
	Node nn = n;
	Node nnOrig = nOrig;

	while ( nn && nnOrig )  
	{
		m_nodeID[ nn ] = numb.m_nodeID[ nnOrig ];
		nn = nn.NextNode();
		nnOrig = nnOrig.NextNode();
	}

}


void NodesNumbers::SetNodeID( const Node &n, NodeID id ) 
{ 
	m_nodeID[ n ] = id; 
	if ( id >= m_currentNodeID) 
		m_currentNodeID = id+1; 
}


void NodesNumbers::Renumber( const Node &root )
{
	Node n = root;
	NodeID id;

	m_currentNodeID = 0;

	while ( n  )  
	{
		id = NewNodeID( n );
		n = n.NextNode();
	}

}


void NodesNumbers::RenumberNew( const Node &root )
{
	Node n = root;
	NodeID id;

	while ( n  )  
	{
		if ( GetNodeID( n ) == InvalidNodeID )
			id = NewNodeID( n );

		n = n.NextNode();
	}

}
