#include <iostream>
#include "SnetPrint.h"


int main()
{
	SnetPrint snet( "snet" );
	Node s1, y1, y2, x1, x2, entry1, exit1;
	Edge e;

	y1 = snet.AddOuterEntry();
	y2 = snet.AddOuterEntry();
	x1 = snet.AddOuterExit();
	x2 = snet.AddOuterExit();

	s1 = snet.AddSubcentre( 1, 1 );

	entry1 = snet.FirstEntry( e, s1 );
	exit1 = snet.FirstExit( e, s1 );

	snet.Connect( y1, entry1 );

	exit1 = snet.FirstExit( e, s1 );
	snet.Connect( exit1, x1 );

	snet.Print();

	NodeAttribute< Node > originalNode;
	SnetPrint complement( "Complement of snet" );
	snet.TransComplement( complement, originalNode );
	complement.Print();

	SnetPrint cc( "Complement of complement of snet" );
	complement.TransComplement( cc, originalNode );
	cc.Print();

	return 0;
}

